#ifndef id372857FBD20C4DD2A9EDDB3A167682AA
#define id372857FBD20C4DD2A9EDDB3A167682AA

#include "doorkeeper/implem/maptypes.hpp"
#include "doorkeeper/primitivetypes.hpp"
#include <cstdint>
#include <vector>
#include <string>
#include <cstddef>

namespace dk {
	template <uint32_t D>
	class BaseMapSource {
	public:
		typedef dk::Vector<D> coords;
		BaseMapSource ( void ) = default;
		virtual ~BaseMapSource ( void ) noexcept = default;

		template <typename T>
		void fetch ( std::vector<T>& parOut, const coords& parFrom, const coords& parTo );

		virtual const coords& mapSize ( void ) const = 0;
		virtual const coords& tileSize ( void ) const = 0;
		virtual MapTypes mapType ( void ) const = 0;
		virtual int layersCount ( void ) const = 0;
		virtual void chainedMaps ( std::vector<std::string>& parOut ) const = 0;

	protected:
		virtual void fetch_raw ( char* parOut, const coords& parFrom, const coords& parTo, std::size_t parSize ) = 0;
	};
} //namespace dk

#endif
